#import <Foundation/Foundation.h>
#include <objc/objc-runtime.h>


@interface Foo : NSObject
{
}

- (void) operate;
- (void) annihilate;

@end


@implementation Foo

- (void) operate
{
   // nothing
}

- (void) annihilate
{
   // nothing
}

@end


@interface NSArray ( Foo)

- (void) operateAnnihilate;
- (void) fastOperateAnnihilate;
- (void) dummyRun;

@end



@implementation NSArray ( Foo)

- (void) operateAnnihilate
{
   SEL  sel;
   IMP  f;
   int  n;
   int  i;
   id   p;
   
   sel = @selector( objectAtIndex:);
   f = [self methodForSelector:sel];
   n = [self count];
   for( i = 0; i < n; i++)
   {
      p = (f)( self, sel, i);
      [p operate];
      [p annihilate];
   }
}


- (void) fastOperateAnnihilate
{
   SEL     operateSel;
   SEL     annihilateSel;
   SEL     sel;
   IMP     f;
   int     n;
   int     i;
   id      p;
   id      (*p_objc_msgSend)( id p, SEL sel, ...);
   
   sel = @selector( objectAtIndex:);
   f = [self methodForSelector:sel];
   n = [self count];
   
   p_objc_msgSend = objc_msgSend;
   operateSel     = @selector( operate);
   annihilateSel  = @selector( annihilate);
   
   for( i = 0; i < n; i++)
   {
      p = (f)( self, sel, i);
      (*p_objc_msgSend)( p, operateSel);
      (*p_objc_msgSend)( p, annihilateSel);
   }
}

- (void) dummyRun
{
   SEL     operateSel;
   SEL     annihilateSel;
   SEL     sel;
   IMP     f;
   int     n;
   int     i;
   id      p;
   id      (*p_objc_msgSend)( id p, SEL sel, ...);
   
   sel = @selector( objectAtIndex:);
   f = [self methodForSelector:sel];
   n = [self count];
   
   for( i = 0; i < n; i++)
   {
      p = (f)( self, sel, i);
   }
}


@end


int main (int argc, const char * argv[])
{
   NSAutoreleasePool  *pool;
   Foo                *p;
   NSMutableArray     *array;
   unsigned int       i;
   
   pool = [[NSAutoreleasePool alloc] init];

   NSLog(@"Setup");

   /* leaks */
   p = [Foo new];
   array = [NSMutableArray array];
   for( i = 0; i < 10000; i++)
      [array addObject:p];
   array = (id) [array copy];

   NSLog(@"[] start");
   for( i = 0; i < 5000; i++)
      [array operateAnnihilate];
   
   NSLog(@"(*)() start");
   for( i = 0; i < 5000; i++)
      [array fastOperateAnnihilate];

   NSLog(@"dummy start");
   for( i = 0; i < 5000; i++)
      [array dummyRun];
   NSLog(@"stop");
   
   [pool release];
   return 0;
}
